#ifndef MATR9D_H
#define MATR9D_H

#include "patrons.h"

class Matr9f;

#define float_to_Vect3f(x)  (*(Vect3f*)&(x))
#define PTR_MATR    ((float*)this)

class Vect3f{
    public:

    inline Vect3f(){x=y=z=0;}
    inline Vect3f(float a,float b, float c){x=a;y=b;z=c;}
    inline float operator[](int i)const{return ((float*)this)[i];}
    inline float& operator[](int i){return ((float*)this)[i];}


    Matr9f v() const;//renvoie la matrice du produit vectoriel correspondant
    void print (const char* nom) const;

    inline void operator+=(Vect3f const&a){x+=a.x;y+=a.y;z+=a.z;}
    inline void operator-=(Vect3f const&a){x-=a.x;y-=a.y;z-=a.z;}
    inline void operator*=(float a){x*=a;y*=a;z*=a;}

    float x;
    float y;
    float z;
};
inline Vect3f operator+(Vect3f const&a,Vect3f const&b){Vect3f c(a);c+=b;return c;}
inline Vect3f operator-(Vect3f const&a,Vect3f const&b){Vect3f c(a);c-=b;return c;}

inline Vect3f operator-(Vect3f const& a){return Vect3f(-a.x,-a.y,-a.z);}

inline Vect3f operator*(float a,Vect3f const& b){Vect3f v(b);v*=a;return v;}
inline float operator*(Vect3f const& a,Vect3f const& b){return a.x*b.x+a.y*b.y+a.z*b.z;}

Vect3f operator^(Vect3f const&a,Vect3f const&b);
Vect3f vectorielle(Vect3f const& a,Vect3f const& b);
Vect3f doubleproduit(Vect3f const& a,Vect3f const& b,Vect3f const& c);
Vect3f findorthogonal(Vect3f const&v);//renvoie un vecteur orthogonal à v de norme 1
Vect3f surfaceprojection(Vect3f normale, Vect3f u);


class Matr9f{
    public:
    Matr9f();
    Matr9f(float d);
    Matr9f(Vect3f const& diagj);
    Matr9f(float a,float b, float c);
    inline Matr9f(Vect3f const&l1, Vect3f const&l2, Vect3f const&l3){Lx=l1;Ly=l2;Lz=l3;}
    inline float operator[](int i)const{return ((float*)this)[i];}
    inline float& operator[](int i){return ((float*)this)[i];}

    void print (const char* nom) const;

    void transpo();
    void operator+=(Matr9f const&a);
    void operator-=(Matr9f const&a);
    void operator*=(float a);
    float norme()const;

    Vect3f Lx;
    Vect3f Ly;
    Vect3f Lz;
};
inline Matr9f operator+(Matr9f const&a,Matr9f const&b){Matr9f c(a);c+=b;return c;}
inline Matr9f operator-(Matr9f const&a,Matr9f const&b){Matr9f c(a);c-=b;return c;}

Matr9f transpo(Matr9f const& m);
inline Matr9f operator-(Matr9f const& a){return Matr9f(-a.Lx,-a.Ly,-a.Lz);}

Vect3f operator*(Matr9f const& m, Vect3f const& a);
Matr9f operator*(Matr9f const& a, Matr9f const& b);
Matr9f operator*(float a, Matr9f const& b);
Matr9f operator!(Matr9f const& a);//fonction inverse
Matr9f pivotaxeangle(Vect3f const& axe, float angle);

void multglmatrix(Matr9f const& m);
void multgltmatrix(Matr9f const& m);


#endif
